from RoboidControl.Messages.Messages import IMessage

from typing import Union

## A network id message invites another participant to a site
#
## This can be sent in response to a ClientMsg
class NetworkIdMsg(IMessage):
    id: int = 0xA1
    length: int = 2
    
    ## Create a network id message
    def __init__(self, arg1: Union[bytes, int]):
        self.network_id: int = 0
        if isinstance(arg1, bytes):
            buffer = bytearray(arg1)
            self.network_id = buffer[1]
        else:
            self.network_id = int(arg1)

    ## Serialize the message into the given buffer
    #
    ## @param buffer_ref A reference to the buffer to use. This should be a list with the buffer as its first and only element
    ## @returns the length of the message
    def Serialize(self, buffer_ref: list[bytearray]) -> int:    
        buffer: bytearray = buffer_ref[0]
        last:int = NetworkIdMsg.length
        buffer[0:last] = [
            NetworkIdMsg.id,
            self.network_id
        ]
        return NetworkIdMsg.length

