from RoboidControl.Messages.Messages import IMessage
from Thing import Thing

from typing import Optional, Union

class ThingMsg(IMessage):
    id = 0x80
    length = 5

    def __init__(self, arg1: Union[bytes, int], thing: Optional[Thing]=None):
        if thing is None:
            buffer = bytes(arg1)
            self.network_id: int = buffer[1]
            self.thing_id: int = buffer[2]
            self.thing_type: int = buffer[3]
            self.parent_id: int = buffer[4]
        else:
            self.network_id = int(arg1)
            self.thing_id = thing.id
            self.thing_type = thing.type
            if thing.parent is not None:
                self.parent_id = thing.parent.id
            else:
                self.parent_id = 0

    def Serialize(self, buffer_ref: list[bytearray]):
      
        print(f'Send ThingMsg [{self.network_id}/{self.thing_id}] {self.thing_type} {self.parent_id}')

        buffer: bytearray = buffer_ref[0]
        buffer[0:ThingMsg.length] = [
            ThingMsg.id,
            self.network_id,
            self.thing_id,
            self.thing_type,
            self.parent_id
        ]
        return ThingMsg.length